#ifndef __LIBCLI_RAW_RAW_PROTO_H__
#define __LIBCLI_RAW_RAW_PROTO_H__

#undef _PRINTF_ATTRIBUTE
#define _PRINTF_ATTRIBUTE(a1, a2) PRINTF_ATTRIBUTE(a1, a2)
/* This file was automatically generated by mkproto.pl. DO NOT EDIT */

#ifndef _PUBLIC_
#define _PUBLIC_
#endif


/* The following definitions come from libcli/raw/rawfile.c  */

struct smbcli_request *smb_raw_rename_send(struct smbcli_tree *tree,
					union smb_rename *parms);
NTSTATUS smb_raw_rename(struct smbcli_tree *tree,
			union smb_rename *parms);
struct smbcli_request *smb_raw_unlink_send(struct smbcli_tree *tree,
					   union smb_unlink *parms);
NTSTATUS smb_raw_unlink(struct smbcli_tree *tree,
			union smb_unlink *parms);
struct smbcli_request *smb_raw_mkdir_send(struct smbcli_tree *tree,
				       union smb_mkdir *parms);
NTSTATUS smb_raw_mkdir(struct smbcli_tree *tree,
		       union smb_mkdir *parms);
struct smbcli_request *smb_raw_rmdir_send(struct smbcli_tree *tree,
				       struct smb_rmdir *parms);
NTSTATUS smb_raw_rmdir(struct smbcli_tree *tree,
		       struct smb_rmdir *parms);
struct smbcli_request *smb_raw_open_send(struct smbcli_tree *tree, union smb_open *parms);
NTSTATUS smb_raw_open_recv(struct smbcli_request *req, TALLOC_CTX *mem_ctx, union smb_open *parms);
NTSTATUS smb_raw_open(struct smbcli_tree *tree, TALLOC_CTX *mem_ctx, union smb_open *parms);
struct smbcli_request *smb_raw_close_send(struct smbcli_tree *tree, union smb_close *parms);
NTSTATUS smb_raw_close(struct smbcli_tree *tree, union smb_close *parms);
struct smbcli_request *smb_raw_lock_send(struct smbcli_tree *tree, union smb_lock *parms);
NTSTATUS smb_raw_lock(struct smbcli_tree *tree, union smb_lock *parms);
struct smbcli_request *smb_raw_chkpath_send(struct smbcli_tree *tree, union smb_chkpath *parms);
NTSTATUS smb_raw_chkpath(struct smbcli_tree *tree, union smb_chkpath *parms);
struct smbcli_request *smb_raw_flush_send(struct smbcli_tree *tree, union smb_flush *parms);
NTSTATUS smb_raw_flush(struct smbcli_tree *tree, union smb_flush *parms);
struct smbcli_request *smb_raw_seek_send(struct smbcli_tree *tree,
					 union smb_seek *parms);
NTSTATUS smb_raw_seek_recv(struct smbcli_request *req,
			   union smb_seek *parms);
NTSTATUS smb_raw_seek(struct smbcli_tree *tree,
		      union smb_seek *parms);

/* The following definitions come from libcli/raw/smb_signing.c  */

BOOL set_smb_signing_common(struct smb_signing_context *sign_info);
void mark_packet_signed(struct request_buffer *out) ;
BOOL signing_good(struct smb_signing_context *sign_info, 
			 unsigned int seq, BOOL good) ;
void sign_outgoing_message(struct request_buffer *out, DATA_BLOB *mac_key, unsigned int seq_num) ;
BOOL check_signed_incoming_message(struct request_buffer *in, DATA_BLOB *mac_key, uint_t seq_num) ;
void smbcli_request_calculate_sign_mac(struct smbcli_request *req);
BOOL smbcli_set_signing_off(struct smb_signing_context *sign_info);
BOOL smbcli_temp_set_signing(struct smbcli_transport *transport);
BOOL smbcli_request_check_sign_mac(struct smbcli_request *req) ;
BOOL smbcli_simple_set_signing(TALLOC_CTX *mem_ctx,
			       struct smb_signing_context *sign_info,
			       const DATA_BLOB *user_session_key, 
			       const DATA_BLOB *response);
BOOL smbcli_transport_simple_set_signing(struct smbcli_transport *transport,
					 const DATA_BLOB user_session_key, 
					 const DATA_BLOB response);
BOOL smbcli_init_signing(struct smbcli_transport *transport) ;

/* The following definitions come from libcli/raw/clisocket.c  */

struct composite_context *smbcli_sock_connect_send(TALLOC_CTX *mem_ctx,
						   const char *host_addr,
						   int port,
						   const char *host_name,
						   struct event_context *event_ctx);
NTSTATUS smbcli_sock_connect_recv(struct composite_context *c,
				  TALLOC_CTX *mem_ctx,
				  struct smbcli_socket **result);
NTSTATUS smbcli_sock_connect(TALLOC_CTX *mem_ctx,
			     const char *host_addr, int port,
			     const char *host_name,
			     struct event_context *event_ctx,
			     struct smbcli_socket **result);
void smbcli_sock_dead(struct smbcli_socket *sock);
void smbcli_sock_set_options(struct smbcli_socket *sock, const char *options);
struct smbcli_socket *smbcli_sock_connect_byname(const char *host, int port,
						 TALLOC_CTX *mem_ctx,
						 struct event_context *event_ctx);

/* The following definitions come from libcli/raw/clitransport.c  */

struct smbcli_transport *smbcli_transport_init(struct smbcli_socket *sock,
					       TALLOC_CTX *parent_ctx, BOOL primary);
void smbcli_transport_dead(struct smbcli_transport *transport, NTSTATUS status);
struct smbcli_request *smbcli_transport_connect_send(struct smbcli_transport *transport,
						     struct nbt_name *calling, 
						     struct nbt_name *called);
NTSTATUS smbcli_transport_connect_recv(struct smbcli_request *req);
BOOL smbcli_transport_connect(struct smbcli_transport *transport,
			      struct nbt_name *calling, 
			      struct nbt_name *called);
uint16_t smbcli_transport_next_mid(struct smbcli_transport *transport);
void smbcli_transport_idle_handler(struct smbcli_transport *transport, 
				   void (*idle_func)(struct smbcli_transport *, void *),
				   uint64_t period,
				   void *private);
BOOL smbcli_transport_process(struct smbcli_transport *transport);
void smbcli_transport_send(struct smbcli_request *req);

/* The following definitions come from libcli/raw/clisession.c  */

struct smbcli_session *smbcli_session_init(struct smbcli_transport *transport, 
					   TALLOC_CTX *parent_ctx, BOOL primary);
struct smbcli_request *smb_raw_sesssetup_send(struct smbcli_session *session, 
					      union smb_sesssetup *parms) ;
NTSTATUS smb_raw_sesssetup_recv(struct smbcli_request *req, 
				TALLOC_CTX *mem_ctx, 
				union smb_sesssetup *parms) ;
NTSTATUS smb_raw_sesssetup(struct smbcli_session *session, 
			   TALLOC_CTX *mem_ctx, union smb_sesssetup *parms) ;
struct smbcli_request *smb_raw_ulogoff_send(struct smbcli_session *session);
NTSTATUS smb_raw_ulogoff(struct smbcli_session *session);
struct smbcli_request *smb_raw_exit_send(struct smbcli_session *session);
NTSTATUS smb_raw_exit(struct smbcli_session *session);

/* The following definitions come from libcli/raw/clitree.c  */

struct smbcli_tree *smbcli_tree_init(struct smbcli_session *session,
				     TALLOC_CTX *parent_ctx, BOOL primary);
struct smbcli_request *smb_raw_tcon_send(struct smbcli_tree *tree, 
					 union smb_tcon *parms);
NTSTATUS smb_raw_tcon_recv(struct smbcli_request *req, TALLOC_CTX *mem_ctx, 
			   union smb_tcon *parms);
NTSTATUS smb_raw_tcon(struct smbcli_tree *tree, TALLOC_CTX *mem_ctx, 
		      union smb_tcon *parms);
NTSTATUS smb_tree_disconnect(struct smbcli_tree *tree);
NTSTATUS smbcli_tree_full_connection(TALLOC_CTX *parent_ctx,
				     struct smbcli_tree **ret_tree, 
				     const char *dest_host, int port,
				     const char *service, const char *service_type,
				     struct cli_credentials *credentials,
				     struct event_context *ev);

/* The following definitions come from libcli/raw/rawrequest.c  */

NTSTATUS smbcli_request_destroy(struct smbcli_request *req);
struct smbcli_request *smbcli_request_setup_nonsmb(struct smbcli_transport *transport, size_t size);
struct smbcli_request *smbcli_request_setup_transport(struct smbcli_transport *transport,
						      uint8_t command, uint_t wct, uint_t buflen);
struct smbcli_request *smbcli_request_setup_session(struct smbcli_session *session,
						    uint8_t command, uint_t wct, size_t buflen);
struct smbcli_request *smbcli_request_setup(struct smbcli_tree *tree,
					    uint8_t command, 
					    uint_t wct, uint_t buflen);
NTSTATUS smbcli_chained_request_setup(struct smbcli_request *req,
				      uint8_t command, 
				      uint_t wct, size_t buflen);
NTSTATUS smbcli_chained_advance(struct smbcli_request *req);
BOOL smbcli_request_send(struct smbcli_request *req);
BOOL smbcli_request_receive(struct smbcli_request *req);
BOOL smbcli_request_receive_more(struct smbcli_request *req);
BOOL smbcli_handle_oplock_break(struct smbcli_transport *transport, uint_t len, const uint8_t *hdr, const uint8_t *vwv);
NTSTATUS smbcli_request_simple_recv(struct smbcli_request *req);
BOOL smbcli_request_is_error(struct smbcli_request *req);
size_t smbcli_req_append_string(struct smbcli_request *req, const char *str, uint_t flags);
size_t smbcli_req_append_string_len(struct smbcli_request *req, const char *str, uint_t flags, int *len);
size_t smbcli_req_append_ascii4(struct smbcli_request *req, const char *str, uint_t flags);
size_t smbcli_req_append_blob(struct smbcli_request *req, const DATA_BLOB *blob);
size_t smbcli_req_append_bytes(struct smbcli_request *req, const uint8_t *bytes, size_t byte_len);
size_t smbcli_req_append_var_block(struct smbcli_request *req, const uint8_t *bytes, uint16_t byte_len);
size_t smbcli_req_pull_ascii(struct smbcli_request *req, TALLOC_CTX *mem_ctx,
			     char **dest, const uint8_t *src, int byte_len, uint_t flags);
size_t smbcli_req_pull_string(struct smbcli_request *req, TALLOC_CTX *mem_ctx, 
			   char **dest, const uint8_t *src, int byte_len, uint_t flags);
DATA_BLOB smbcli_req_pull_blob(struct smbcli_request *req, TALLOC_CTX *mem_ctx, const uint8_t *src, int byte_len);
BOOL smbcli_raw_pull_data(struct smbcli_request *req, const uint8_t *src, int len, uint8_t *dest);
void smbcli_push_nttime(void *base, uint16_t offset, NTTIME t);
NTTIME smbcli_pull_nttime(void *base, uint16_t offset);
size_t smbcli_blob_pull_string(struct smbcli_session *session,
			       TALLOC_CTX *mem_ctx,
			       const DATA_BLOB *blob, 
			       struct smb_wire_string *dest, 
			       uint16_t len_offset, uint16_t str_offset, 
			       uint_t flags);
size_t smbcli_blob_pull_unix_string(struct smbcli_session *session,
			    TALLOC_CTX *mem_ctx,
			    DATA_BLOB *blob, 
			    const char **dest, 
			    uint16_t str_offset, 
			    uint_t flags);
size_t smbcli_blob_append_string(struct smbcli_session *session,
			      TALLOC_CTX *mem_ctx, DATA_BLOB *blob, 
			      const char *str, uint_t flags);

/* The following definitions come from libcli/raw/rawreadwrite.c  */

struct smbcli_request *smb_raw_read_send(struct smbcli_tree *tree, union smb_read *parms);
NTSTATUS smb_raw_read_recv(struct smbcli_request *req, union smb_read *parms);
NTSTATUS smb_raw_read(struct smbcli_tree *tree, union smb_read *parms);
struct smbcli_request *smb_raw_write_send(struct smbcli_tree *tree, union smb_write *parms);
NTSTATUS smb_raw_write_recv(struct smbcli_request *req, union smb_write *parms);
NTSTATUS smb_raw_write(struct smbcli_tree *tree, union smb_write *parms);

/* The following definitions come from libcli/raw/rawsearch.c  */

NTSTATUS smb_raw_search_common(TALLOC_CTX *mem_ctx, 
			       enum smb_search_data_level level,
			       const DATA_BLOB *blob,
			       union smb_search_data *data,
			       uint_t *next_ofs,
			       uint_t str_flags);
NTSTATUS smb_raw_search_first(struct smbcli_tree *tree,
			      TALLOC_CTX *mem_ctx,
			      union smb_search_first *io, void *private,
			      BOOL (*callback)(void *private, union smb_search_data *file));
NTSTATUS smb_raw_search_next(struct smbcli_tree *tree,
			     TALLOC_CTX *mem_ctx,
			     union smb_search_next *io, void *private,
			     BOOL (*callback)(void *private, union smb_search_data *file));
NTSTATUS smb_raw_search_close(struct smbcli_tree *tree,
			      union smb_search_close *io);

/* The following definitions come from libcli/raw/rawsetfileinfo.c  */

BOOL smb_raw_setfileinfo_passthru(TALLOC_CTX *mem_ctx,
				  enum smb_setfileinfo_level level,
				  union smb_setfileinfo *parms, 
				  DATA_BLOB *blob);
struct smbcli_request *smb_raw_setfileinfo_send(struct smbcli_tree *tree,
					     union smb_setfileinfo *parms);
NTSTATUS smb_raw_setfileinfo(struct smbcli_tree *tree,
			     union smb_setfileinfo *parms);
struct smbcli_request *smb_raw_setpathinfo_send(struct smbcli_tree *tree,
					     union smb_setfileinfo *parms);
NTSTATUS smb_raw_setpathinfo(struct smbcli_tree *tree,
			     union smb_setfileinfo *parms);

/* The following definitions come from libcli/raw/raweas.c  */

size_t ea_list_size(uint_t num_eas, struct ea_struct *eas);
size_t ea_list_size_chained(uint_t num_eas, struct ea_struct *eas);
void ea_put_list(uint8_t *data, uint_t num_eas, struct ea_struct *eas);
void ea_put_list_chained(uint8_t *data, uint_t num_eas, struct ea_struct *eas);
uint_t ea_pull_struct(const DATA_BLOB *blob, 
		      TALLOC_CTX *mem_ctx,
		      struct ea_struct *ea);
NTSTATUS ea_pull_list(const DATA_BLOB *blob, 
		      TALLOC_CTX *mem_ctx,
		      uint_t *num_eas, struct ea_struct **eas);
NTSTATUS ea_pull_list_chained(const DATA_BLOB *blob, 
			      TALLOC_CTX *mem_ctx,
			      uint_t *num_eas, struct ea_struct **eas);
NTSTATUS ea_pull_name_list(const DATA_BLOB *blob, 
			   TALLOC_CTX *mem_ctx,
			   uint_t *num_names, struct ea_name **ea_names);
BOOL ea_push_name_list(TALLOC_CTX *mem_ctx,
		       DATA_BLOB *data, uint_t num_names, struct ea_name *eas);

/* The following definitions come from libcli/raw/rawtrans.c  */

NTSTATUS smb_raw_trans2_recv(struct smbcli_request *req,
			     TALLOC_CTX *mem_ctx,
			     struct smb_trans2 *parms);
NTSTATUS smb_raw_trans_recv(struct smbcli_request *req,
			     TALLOC_CTX *mem_ctx,
			     struct smb_trans2 *parms);
struct smbcli_request *smb_raw_trans_send_backend(struct smbcli_tree *tree,
						  struct smb_trans2 *parms,
						  uint8_t command);
struct smbcli_request *smb_raw_trans_send(struct smbcli_tree *tree,
				       struct smb_trans2 *parms);
struct smbcli_request *smb_raw_trans2_send(struct smbcli_tree *tree,
				       struct smb_trans2 *parms);
NTSTATUS smb_raw_trans2(struct smbcli_tree *tree,
			TALLOC_CTX *mem_ctx,
			struct smb_trans2 *parms);
NTSTATUS smb_raw_trans(struct smbcli_tree *tree,
		       TALLOC_CTX *mem_ctx,
		       struct smb_trans2 *parms);
NTSTATUS smb_raw_nttrans_recv(struct smbcli_request *req,
			      TALLOC_CTX *mem_ctx,
			      struct smb_nttrans *parms);
struct smbcli_request *smb_raw_nttrans_send(struct smbcli_tree *tree,
					 struct smb_nttrans *parms);
NTSTATUS smb_raw_nttrans(struct smbcli_tree *tree,
			 TALLOC_CTX *mem_ctx,
			 struct smb_nttrans *parms);
size_t smb_raw_max_trans_data(struct smbcli_tree *tree, size_t param_size);

/* The following definitions come from libcli/raw/clioplock.c  */

_PUBLIC_ BOOL smbcli_oplock_ack(struct smbcli_tree *tree, uint16_t fnum, uint16_t ack_level);
_PUBLIC_ void smbcli_oplock_handler(struct smbcli_transport *transport, 
			BOOL (*handler)(struct smbcli_transport *, uint16_t, uint16_t, uint8_t, void *),
			void *private);

/* The following definitions come from libcli/raw/rawnegotiate.c  */

struct smbcli_request *smb_raw_negotiate_send(struct smbcli_transport *transport, 
					      int maxprotocol);
NTSTATUS smb_raw_negotiate_recv(struct smbcli_request *req);
NTSTATUS smb_raw_negotiate(struct smbcli_transport *transport, int maxprotocol);

/* The following definitions come from libcli/raw/rawfsinfo.c  */

struct smbcli_request *smb_raw_fsinfo_send(struct smbcli_tree *tree, 
					TALLOC_CTX *mem_ctx, 
					union smb_fsinfo *fsinfo);
NTSTATUS smb_raw_fsinfo_passthru_parse(DATA_BLOB blob, TALLOC_CTX *mem_ctx, 
				       enum smb_fsinfo_level level,
				       union smb_fsinfo *fsinfo);
NTSTATUS smb_raw_fsinfo_recv(struct smbcli_request *req, 
			     TALLOC_CTX *mem_ctx, 
			     union smb_fsinfo *fsinfo);
NTSTATUS smb_raw_fsinfo(struct smbcli_tree *tree, 
			TALLOC_CTX *mem_ctx, 
			union smb_fsinfo *fsinfo);

/* The following definitions come from libcli/raw/rawfileinfo.c  */

NTSTATUS smbcli_parse_stream_info(DATA_BLOB blob, TALLOC_CTX *mem_ctx,
				  struct stream_information *io);
NTSTATUS smb_raw_fileinfo_passthru_parse(const DATA_BLOB *blob, TALLOC_CTX *mem_ctx, 
					 enum smb_fileinfo_level level,
					 union smb_fileinfo *parms);
struct smbcli_request *smb_raw_fileinfo_send(struct smbcli_tree *tree,
					     union smb_fileinfo *parms);
NTSTATUS smb_raw_fileinfo_recv(struct smbcli_request *req,
			       TALLOC_CTX *mem_ctx,
			       union smb_fileinfo *parms);
NTSTATUS smb_raw_fileinfo(struct smbcli_tree *tree,
			  TALLOC_CTX *mem_ctx,
			  union smb_fileinfo *parms);
struct smbcli_request *smb_raw_pathinfo_send(struct smbcli_tree *tree,
					     union smb_fileinfo *parms);
NTSTATUS smb_raw_pathinfo_recv(struct smbcli_request *req,
			       TALLOC_CTX *mem_ctx,
			       union smb_fileinfo *parms);
NTSTATUS smb_raw_pathinfo(struct smbcli_tree *tree,
			  TALLOC_CTX *mem_ctx,
			  union smb_fileinfo *parms);

/* The following definitions come from libcli/raw/rawnotify.c  */

struct smbcli_request *smb_raw_changenotify_send(struct smbcli_tree *tree, union smb_notify *parms);
NTSTATUS smb_raw_changenotify_recv(struct smbcli_request *req, 
				   TALLOC_CTX *mem_ctx, union smb_notify *parms);
struct smbcli_request *smbcli_handle_ntcancel_reply(struct smbcli_request *req,
						    size_t len, const uint8_t *hdr);
NTSTATUS smb_raw_ntcancel(struct smbcli_request *oldreq);

/* The following definitions come from libcli/raw/rawioctl.c  */

struct smbcli_request *smb_raw_ioctl_send(struct smbcli_tree *tree, union smb_ioctl *parms);
NTSTATUS smb_raw_ioctl_recv(struct smbcli_request *req,
			    TALLOC_CTX *mem_ctx, union smb_ioctl *parms);
_PUBLIC_ NTSTATUS smb_raw_ioctl(struct smbcli_tree *tree, 
		TALLOC_CTX *mem_ctx, union smb_ioctl *parms);

/* The following definitions come from libcli/raw/rawacl.c  */

struct smbcli_request *smb_raw_query_secdesc_send(struct smbcli_tree *tree, 
						  union smb_fileinfo *io);
NTSTATUS smb_raw_query_secdesc_recv(struct smbcli_request *req, 
				    TALLOC_CTX *mem_ctx, 
				    union smb_fileinfo *io);
NTSTATUS smb_raw_query_secdesc(struct smbcli_tree *tree, 
			       TALLOC_CTX *mem_ctx, 
			       union smb_fileinfo *io);
struct smbcli_request *smb_raw_set_secdesc_send(struct smbcli_tree *tree, 
						union smb_setfileinfo *io);
NTSTATUS smb_raw_set_secdesc(struct smbcli_tree *tree, 
			     union smb_setfileinfo *io);

/* The following definitions come from libcli/raw/rawdate.c  */

void raw_push_dos_date(struct smbcli_transport *transport,
		      uint8_t *buf, int offset, time_t unixdate);
void raw_push_dos_date2(struct smbcli_transport *transport,
		       uint8_t *buf, int offset, time_t unixdate);
void raw_push_dos_date3(struct smbcli_transport *transport,
		       uint8_t *buf, int offset, time_t unixdate);
time_t raw_pull_dos_date(struct smbcli_transport *transport, 
			 const uint8_t *date_ptr);
time_t raw_pull_dos_date2(struct smbcli_transport *transport, 
			  const uint8_t *date_ptr);
time_t raw_pull_dos_date3(struct smbcli_transport *transport,
			  const uint8_t *date_ptr);

/* The following definitions come from libcli/raw/rawlpq.c  */

struct smbcli_request *smb_raw_lpq_send(struct smbcli_tree *tree,
					union smb_lpq *parms);
NTSTATUS smb_raw_lpq_recv(struct smbcli_request *req, union smb_lpq *parms);
NTSTATUS smb_raw_lpq(struct smbcli_tree *tree, union smb_lpq *parms);
#undef _PRINTF_ATTRIBUTE
#define _PRINTF_ATTRIBUTE(a1, a2)

#endif /* __LIBCLI_RAW_RAW_PROTO_H__ */

